<template>
  <div v-if="flight" class="ticket">
    <div class="ticket-info">
      <div class="ticket-info-main">
        <img
          :src="require(`@/assets/images/${flight.validating_carrier}.png`)"
          alt="jddk"
          class="ticket-info-main-logo"
        />
        <div class="ticket-info-main-airline">{{flight.itineraries[0][0].carrier_name}}</div>
        <div class="ticket-info-main-departure">
          <div
            class="ticket-info-main-departure-date"
          >{{getDate(flight.itineraries[0][0].dep_date)}}</div>
          <div
            class="ticket-info-main-departure-time"
          >{{getTime(flight.itineraries[0][0].dep_date)}}</div>
        </div>
        <div class="ticket-info-main-route">
          <div class="ticket-info-main-route-names">
            <span
              class="ticket-info-main-route-names-from"
            >{{flight.itineraries[0][0].segments[0].origin_code}}</span>
            <span
              class="ticket-info-main-route-names-time"
            >{{getFlightTime(flight.itineraries[0][0].traveltime*1000)}}</span>
            <span
              class="ticket-info-main-route-names-to"
            >{{flight.itineraries[0][0].segments[flight.itineraries[0][0].segments.length-1].dest_code}}</span>
          </div>
          <img class="ticket-info-main-route-line" src="@/assets/images/line.svg" alt />
          <span
            class="ticket-info-main-route-stop"
            :class="{'ticket-info-main-route-stop-direct': flight.itineraries[0][0].stops==0}"
          >{{getStops(flight.itineraries[0][0])}}</span>
        </div>
        <div class="ticket-info-main-arrival">
          <div class="ticket-info-main-arrival-date">
            {{getArrDate(flight.itineraries[0][0])}}
            <span class="red">+1</span>
          </div>
          <div class="ticket-info-main-arrival-time">{{getArrTime(flight.itineraries[0][0])}}</div>
        </div>
      </div>
      <div class="ticket-info-additional">
        <span class="ticket-info-additional-details">{{$t('lang.ticket.details')}}</span>
        <span class="ticket-info-additional-condition">{{$t('lang.ticket.condition')}}</span>
        <span v-if="!flight.refundable" class="ticket-info-additional-refund">
          <img class="ticket-info-additional-refund-logo" src="@/assets/images/no_refund.svg" alt />
          {{$t('lang.ticket.no_refund')}}
        </span>
      </div>
    </div>
    <div class="ticket-price">
      <span class="ticket-price-value">{{flight.price}} ₸</span>
      <div class="ticket-price-btn">
        <span class="ticket-price-btn-text">{{$t('lang.ticket.select')}}</span>
      </div>
      <span class="ticket-price-text">{{$t('lang.ticket.price')}}</span>
      <div v-if="!flight.services['20KG']" class="ticket-price-baggage">
        <span class="ticket-price-baggage-text">{{$t('lang.ticket.no_baggage')}}</span>
        <div class="ticket-price-baggage-btn">
          <span class="ticket-price-baggage-btn-text">+ {{$t('lang.ticket.add_baggage')}}</span>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: ["flight"],
  computed: {},
  methods: {
    getTime(datetime) {
      const options = {
        hour12: false,
        hour: "2-digit",
        minute: "2-digit"
      };
      const date = new Date(datetime);
      return date.toLocaleTimeString([], options);
    },
    getDate(datetime) {
      const date = new Date(datetime);

      let options = {
        day: "2-digit",
        month: "short",
        weekday: "short"
      };
      let formatted = date.toLocaleDateString("ru-RU", options);
      const day = formatted.split(", ")[1].slice(0, -1);
      const weekday = formatted.trim(".").split(", ")[0];
      formatted = `${day}, ${weekday}`;
      return formatted;
    },
    getArrDate(data) {
      return this.getDate(new Date(data.arr_date).getTime());
    },
    getArrTime(data) {
      let date = new Date(data.arr_date);
      return this.getTime(date.getTime());
    },
    getFlightTime(time) {
      const options = {
        hour12: false,
        day: "numeric",
        hour: "numeric",
        minute: "2-digit"
      };
      let date = new Date(time);
      date = date.toLocaleTimeString([], options);
      const day = parseInt(date.split(", ")[0]) - 1;
      const hour = parseInt(date.split(", ")[1].split(":")[0]);
      const minute = parseInt(date.split(", ")[1].split(":")[1]);
      return `${day ? day + "д" : ""} ${hour != 24 ? hour + "ч" : ""} ${
        minute == 60 ? "" : minute == 0 ? "" : minute + "м"
      }`;
    },
    getStops(data) {
      if (data.stops == 0) {
        return this.$t("lang.ticket.direct");
      } else if (data.stops == 1) {
        return `${this.$t("lang.ticket.through")} ${
          data.segments[0].airport_dest
        }, ${this.getFlightTime(data.layovers[0] * 1000)}`;
      } else {
        return `${data.stops} ${this.$t("lang.ticket.transfers")}`;
      }
    }
  }
};
</script>

<style lang='scss' scoped>
.ticket {
  background: #ffffff;
  box-shadow: 0px 2px 4px rgba(0, 0, 0, 0.15);
  border-radius: 4px;
  margin-bottom: 12px;
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: center;
  &-price {
    flex: 0.3;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    width: 240px;
    background: #f5f5f5;
    border-radius: 0px 4px 4px 0px;
    padding: 20px 0;
    &-value {
      font-family: Arial;
      font-size: 24px;
      line-height: 28px;
      text-align: center;
      margin-bottom: 13px;
    }
    &-btn {
      cursor: pointer;
      background: #55bb06;
      border-radius: 4px;
      box-shadow: none;
      width: 200px;
      height: 40px;
      text-align: center;
      display: flex;
      justify-content: center;
      align-items: center;
      margin: 0 16px;
      margin-bottom: 8px;
      &:hover {
        box-shadow: 0.1px 0.1px 0.1px 2px rgba(85, 187, 6, 0.35);
        transition: all 0.1s ease-in-out;
      }
      &-text {
        font-style: normal;
        font-weight: bold;
        font-size: 18px;
        line-height: 25px;
        color: #ffffff;
      }
    }
    &-text {
      font-style: normal;
      font-weight: normal;
      font-size: 12px;
      line-height: 16px;
      text-align: center;
      color: #707276;
      margin-bottom: 15px;
    }
    &-baggage {
      display: flex;
      width: 100%;
      padding: 0 20px;
      justify-content: space-between;
      &-text {
        font-style: normal;
        font-weight: normal;
        font-size: 12px;
        line-height: 16px;
        display: flex;
        align-items: center;
        text-align: center;
      }
      &-btn {
        cursor: pointer;
        background: #eaf0fa;
        border-radius: 2px;
        padding: 0 8px;
        text-align: center;
        color: #5763b3;
        &-text {
          font-style: normal;
          font-weight: 600;
          font-size: 12px;
          line-height: 16px;
          text-align: center;
        }
        &:hover {
          background: #5763b3;
          color: #eaf0fa;
          transition: all 0.1s ease-in-out;
        }
      }
    }
  }
  &-info {
    flex: 0.7;
    display: flex;
    flex-direction: column;
    justify-content: space-evenly;
    margin-left: 44px;
    padding: 20px 0;
    &-main {
      display: flex;
      align-items: center;
      &-logo {
        height: 20px;
        margin-right: 11.79px;
      }
      &-airline {
        font-style: normal;
        font-weight: 600;
        font-size: 14px;
        line-height: 19px;
        display: flex;
        align-items: center;
        margin-right: 13px;
        width: 100px;
      }
      &-departure {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        margin-right: 27.44px;
        &-time {
          font-style: normal;
          font-weight: 600;
          font-size: 24px;
          line-height: 33px;
        }
        &-date {
          font-style: normal;
          font-weight: normal;
          font-size: 12px;
          line-height: 16px;
        }
      }
      &-route {
        margin-right: 31.56px;
        display: flex;
        flex-direction: column;
        &-line {
          width: 168px;
        }
        &-names {
          display: flex;
          justify-content: space-between;
          align-items: center;
          &-from,
          &-to {
            font-style: normal;
            font-weight: normal;
            font-size: 10px;
            line-height: 12px;
            text-align: center;
            color: #b9b9b9;
          }
          &-time {
            font-style: normal;
            font-weight: normal;
            font-size: 12px;
            line-height: 18px;
            text-align: center;
          }
        }
        &-stop {
          font-style: normal;
          font-weight: normal;
          font-size: 12px;
          line-height: 16px;
          text-align: center;
          color: #ff9900;
          &-direct {
            color: #55bb06;
          }
        }
      }
      &-arrival {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        &-time {
          font-style: normal;
          font-weight: 600;
          font-size: 24px;
          line-height: 33px;
        }
        &-date {
          display: flex;
          font-style: normal;
          font-weight: normal;
          font-size: 12px;
          line-height: 16px;
        }
      }
    }
    &-additional {
      align-self: end;
      &-details {
        font-style: normal;
        font-weight: normal;
        font-size: 12px;
        line-height: 16px;
        color: #7284e4;
        margin-right: 23px;
        border-bottom: 1px dashed #7284e4;
      }
      &-condition {
        font-style: normal;
        font-weight: normal;
        font-size: 12px;
        line-height: 16px;
        color: #7284e4;
        margin-right: 49.5px;
        border-bottom: 1px dashed #7284e4;
      }
      &-refund {
        font-family: Arial;
        font-size: 12px;
        line-height: 14px;
        text-align: center;
        color: #707276;
      }
    }
  }
  .red {
    font-style: normal;
    font-weight: 600;
    font-size: 10px;
    line-height: 14px;
    display: flex;
    align-items: center;

    /* #FF3724 */

    color: rgba(255, 55, 36, 0.8);
  }
}

@media only screen and (max-width: 1150px) {
  .ticket {
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    &-info {
      padding: 30px 0;
      margin: 0 auto;
    }
    &-price {
      padding: 10px 0;
      width: 100%;
      &-text {
        margin-bottom: 5px;
      }
      &-baggage {
        justify-content: center;
        &-text {
          margin-right: 10px;
        }
      }
    }
  }
  @media only screen and (max-width: 530px) {
    .ticket {
      &-price {
        display: grid;
        grid-template-columns: 50% 50%;
        padding: 0;
        padding-bottom: 10px;
        &-btn {
          width: 100%;
          margin: 0;
          border-radius: unset;
        }
        &-value {
          margin: 0;
        }
        &-baggage {
          grid-row: 3;
          grid-column-start: 1;
          grid-column-end: 3;
        }
        &-text {
          border-top: 1px solid lightgray;
          padding-top: 10px;
          grid-column-start: 1;
          grid-column-end: 3;
        }
      }
      &-info {
        padding: 10px 0;
        &-main {
          display: grid;
          grid-template-columns: 30% 40% 30%;
          gap: 10px 10px;
          &-logo {
            grid-row: 1;
            grid-column-start: 1;
            grid-column-end: 3;
          }
          &-airline {
            grid-row: 1;
            grid-column-start: 1;
            grid-column-end: 3;
            margin-left: 32px;
          }
          &-departure {
            grid-row: 2;
            grid-column: 1;
            margin: 0;
            text-align: center;
          }
          &-route {
            grid-row: 2;
            grid-column: 2;
            margin: 0;
            text-align: center;
            &-line {
              width: initial;
              width: -webkit-fill-available;
            }
          }
          &-arrival {
            text-align: center;
            grid-row: 2;
            grid-column: 3;
            margin: 0;
          }
        }
      }
    }
  }
  @media only screen and (max-width: 400px) {
    .ticket {
      &-info {
        padding: 10px 0;
        margin: 0;
        text-align: center;
        &-main {
          display: grid;
          grid-template-columns: 50% 50%;
          gap: 10px 0;
          &-logo {
            grid-row: 1;
            grid-column-start: 1;
            grid-column-end: 3;
            margin-left: 32px;
          }
          &-airline {
            grid-row: 1;
            grid-column-start: 1;
            grid-column-end: 3;
            margin-left: 64px;
          }
          &-departure {
            grid-row: 2;
            grid-column: 1;
            margin: 0;
            text-align: center;
          }
          &-route {
            grid-row: 3;
            grid-column-start: 1;
            grid-column-end: 3;
            width: 80%;
            margin: 0 auto;
            text-align: center;
            &-line {
              width: initial;
              width: -webkit-fill-available;
            }
          }
          &-arrival {
            text-align: center;
            grid-row: 2;
            grid-column: 2;
            margin: 0;
          }
        }
        &-additional {
          margin-top: 20px;
          display: grid;
          grid-template-columns: 100%;
          gap: 10px 0;
          align-self: auto;
          &-details,
          &-condition,
          &-refund {
            text-align: center;
            margin: 0;
            border-bottom: unset;
          }
        }
      }
    }
  }
}
</style>